(function( $ ) {
	'use strict';

	/**
	 * All of the code for your admin-facing JavaScript source
	 * should reside in this file.
	 *
	 * Note: It has been assumed you will write jQuery code here, so the
	 * $ function reference has been prepared for usage within the scope
	 * of this function.
	 *
	 * This enables you to define handlers, for when the DOM is ready:
	 *
	 * $(function() {
	 *
	 * });
	 *
	 * When the window is loaded:
	 *
	 * $( window ).load(function() {
	 *
	 * });
	 *
	 * ...and/or other possibilities.
	 *
	 * Ideally, it is not considered best practise to attach more than a
	 * single DOM-ready or window-load handler for a particular page.
	 * Although scripts in the WordPress core, Plugins and Themes may be
	 * practising this, we should strive to set a better example in our own work.
	 */
	 
	 
	 
	 
	$(function() {
		$( "#e-junkie_options" ).validate();

		$( "#e-junkie-client-id" ).rules( "add", {
		  required: true,
		  digits: true,
		  messages: {
			required: "Client Id Required",
			digits: jQuery.validator.format("Client Id must be a number")
		  }
		});
		$( "#e-junkie-shop_name" ).rules( "add", {
		  required: true,
		  messages: {
			required: "Shop Name Required"
		  }
		});
		$( "#e-junkie-logo" ).rules( "add", {
		  required: true,
		  messages: {
			required: "Shop Page Logo Is Required"
		  }
		});
		
		
	});

})( jQuery );


