<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://www.e-junkie.com/wordpress-plugins/
 * @since      1.0.0
 *
 * @package    E_Junkie
 * @subpackage E_Junkie/admin/partials
 */
?>

<!-- This file should primarily consist of HTML with a little bit of PHP. -->
<?php
 $options = get_option($this->plugin_name);
 if(isset($options['client-id']) && $options['client-id']!="") {
$Page = new stdClass();
$Client = new stdClass();
$Client->client_id = $options['client-id'];
//no of related products to show
$Page->maxRelated = 5;
$Page->selectedCategory = null;
$Page->location=new stdClass();
//deprecated, but still some clients use this feature, we don't need this in WP plugin
$Page->selectedCategoryLevel = null;
$Page->theme=($options['theme']!="")?$options['theme']:"default";

$apikey=$options['client-api-key'];
$button_code=false;
$item='';

$EJ = new EjunkieWPPlugin\EJParser($Client->client_id, $tag, $item, $page, $apikey, true);
 }
?>

<div class="wrap">

    <h1><?php echo esc_html(get_admin_page_title()); ?></h1>
    <?php
        //Grab all options
        $options = get_option($this->plugin_name);
 
       $active_tab = isset($_GET['tab']) ? $_GET['tab'] : 'general';
       if(isset($_GET['tab'])) $active_tab = $_GET['tab'];
        
	?>
    <form method="post" name="e-junkie_options" id="e-junkie_options" action="options.php">
		
		<h2 class="nav-tab-wrapper">
		<?php submit_button('Save Changes', 'button-primary right','submit', false); ?>
            <a href="?page=e-junkie&tab=general" class="nav-tab <?php echo ($active_tab == 'general') ? 'nav-tab-active' : ''; ?>">Shop Setting</a>
			
			<?php if(isset($options['client-id']) && $options['client-id']!="") { ?>
            <a href="?page=e-junkie&tab=preferences" class="nav-tab <?php echo ($active_tab == 'preferences') ? 'nav-tab-active' : ''; ?>">Shop Preferences</a>
			
			<?php }?>
			
        </h2>
		
		<?php
			settings_fields($this->plugin_name);
			do_settings_sections($this->plugin_name);
		?>

        <table style="display:<?php echo ($active_tab=='general')?'block':'none'; ?>;" class="form-table e-junkie-table-opt" id="general">
           <tr>
				<th scope="row"><label for="<?php echo $this->plugin_name; ?>-client-id"><?php esc_attr_e('Client ID', $this->plugin_name); ?> <em class="required">*</em></label></th>
				<td><input type="text" class="regular-text" id="<?php echo $this->plugin_name; ?>-client-id" name="<?php echo $this->plugin_name; ?>[client-id]" value="<?php echo $options['client-id'] ;?>" /></td>
		   </tr>
		   <tr>
				<th scope="row"><label for="<?php echo $this->plugin_name; ?>-client-api-key"><?php esc_attr_e('Client API Key', $this->plugin_name); ?> </label></th>
				<td><input type="text" class="regular-text" id="<?php echo $this->plugin_name; ?>-client-api-key" name="<?php echo $this->plugin_name; ?>[client-api-key]" value="<?php echo $options['client-api-key'] ;?>" /></td>
		   </tr>
		    <tr>
				<th scope="row"><label for="<?php echo $this->plugin_name; ?>-shop"><?php esc_attr_e('Shop URL', $this->plugin_name); ?> </label></th>
				<td><?php echo site_url(); ?>/<input type="text" class="regular-text" id="<?php echo $this->plugin_name; ?>-shop" name="<?php echo $this->plugin_name; ?>[shop]" value="<?php echo $options['shop'] ;?>" />/
				
				
				<span><a href="<?php echo site_url(); ?>/<?php echo $options['shop'] ;?>" target="_blank" >View</a></span>
				
				</td>
			
		   </tr>
		   <tr>
				<th scope="row"><label for="<?php echo $this->plugin_name; ?>-shop_name"><?php esc_attr_e('Shop Name', $this->plugin_name); ?> <em class="required">*</em></label></th>
				<td><input type="text" class="regular-text" id="<?php echo $this->plugin_name; ?>-shop_name" name="<?php echo $this->plugin_name; ?>[shop_name]" value="<?php echo $options['shop_name'] ;?>" /></td>
				
		   </tr>
		</table>
		<?php if(isset($options['client-id']) && $options['client-id']!="") { ?>
		
		<style>
		.multiselect {
			  width: 300px;
			}

			.selectBox {
			  position: relative;
			}

			.selectBox select {
			  width: 100%;
			  font-weight: bold;
			}

			.overSelect {
			  position: absolute;
			  left: 0;
			  right: 0;
			  top: 0;
			  bottom: 0;
			}

			.checkboxes {
			  display: none;
			  border: 1px #dadada solid;
			  height:250px;
			  overflow:auto;
			}

			.checkboxes label {
			  display: block;
			 width:100%;
			}

			.checkboxes label:hover {
			  background-color: #1e90ff;
			}
			.list_container{
				width:300px; 
				height:300px; 
				background-color:#ccc;
				overflow:auto;
				border-radius:6px;
			}
			.list_container ul{
				
				padding:5px;
			}
			.list_container ul li{
						
				padding:5px;
					font-weight:600;
			}
		</style>
		
		
		<script>
		var expandedPUP = false;
		var expandedPDOWN = false;
		var expandedPHID = false;

		function showCheckboxesPUP() {
		  var checkboxes = document.getElementById("checkboxesPUP");
		  if (!expandedPUP) {
			checkboxes.style.display = "block";
			expandedPUP = true;
		  } else {
			checkboxes.style.display = "none";
			expandedPUP = false;
		  }
		}
		function showCheckboxesPDOWN() {
		  var checkboxes = document.getElementById("checkboxesPDOWN");
		  if (!expandedPDOWN) {
			checkboxes.style.display = "block";
			expandedPDOWN = true;
		  } else {
			checkboxes.style.display = "none";
			expandedPDOWN = false;
		  }
		}
		function showCheckboxesPHID() {
		  var checkboxes = document.getElementById("checkboxesPHID");
		  if (!expandedPHID) {
			checkboxes.style.display = "block";
			expandedPHID = true;
		  } else {
			checkboxes.style.display = "none";
			expandedPHID = false;
		  }
		}
		
		
		function checkboxChange(ele,list){
			
			if(ele.checked){
				jQuery("#"+list).append('<li id="item_'+ele.value+'">'+ele.nextSibling.data+'</li>');
			}
			else{
				
				jQuery("#"+list+">#item_"+ele.value).remove();
			}
			
		}
		</script>
		
		
		 <table style="display:<?php echo ($active_tab=='preferences')?'block':'none'; ?>;" class="form-table e-junkie-table-opt" id="preferences">
			<tr>
				<th scope="row"><label for="<?php echo $this->plugin_name; ?>-outofstock"><?php esc_attr_e('Hide Out of Stock Products', $this->plugin_name); ?></label></th>
				<td>				
				<select id="<?php echo $this->plugin_name; ?>-outofstock" name="<?php echo $this->plugin_name; ?>[outofstock]">
				<option value="yes" <?php echo ($options['outofstock']=='yes')?"selected" :''; ?> >YES</option>
				<option value="no" <?php echo ($options['outofstock']=='no')?"selected" :''; ?> >NO</option>
				</td>
				<td>&nbsp;</td>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<th scope="row"><label for="<?php echo $this->plugin_name; ?>-related"><?php esc_attr_e('Show Related Products', $this->plugin_name); ?></label></th>
				<td>				
				<select id="<?php echo $this->plugin_name; ?>-related" name="<?php echo $this->plugin_name; ?>[related]">
				<?php if(!isset($options['related'])){
					$options['related']=5;
				}
				for($i=0;$i<=10;$i++){ ?>
				<option value="<?php echo $i; ?>" <?php echo ($options['related']==$i)?"selected" :''; ?> ><?php echo $i; ?></option>
				<?php } ?>
				</td>
				<td>&nbsp;</td>
				<td>&nbsp;</td>
			</tr>
           <tr>
		   <td>
			   <fieldset>
				<legend><h3>Pinned Up Products</h3></legend>
			   
			    <div class="list_container">
				<ul id="puplist">
				<?php 
				if(count($options['pup'])){
					foreach($EJ->allProducts as $product){ 

						if(in_array($product->number,$options['pup'])){ ?>
							<li id="item_<?php echo $product->number;?>"><?php echo $product->name;?></li>	
							
					<?php  }
					}
				}
				?>
				</ul>
				</div>
				<div class="multiselect">
					<div class="selectBox" onclick="showCheckboxesPUP()">
					  <select>
						<option>Select Product</option>
					  </select>
					  <div class="overSelect"></div>
					</div>
					<div class="checkboxes" id="checkboxesPUP">
						<?php foreach($EJ->allProducts as $product){
							$checked="";
							if(count($options['pup'])){
								if(in_array($product->number,$options['pup'])){
								$checked='checked';
								}
							}
						?>
						
					  <label for="pup_item_<?php echo $product->number; ?>">
					  
					  
						<input onclick="checkboxChange(this,'puplist')" <?php echo $checked;?> name="<?php echo $this->plugin_name; ?>[pup][]" value="<?php echo $product->number; ?>" type="checkbox" id="pup_item_<?php echo $product->number; ?>" /><?php echo $product->name; ?></label>
						<?php } ?>
						
					</div>
				</div>
			</fieldset>
		   </td>
		   <td>
				<fieldset>
					<legend><h3>Pinned Down Products</h3></legend>
				<div class="list_container">
				<ul id="pdownlist">
				<?php 
				
				if(count($options['pdown'])){
					foreach($EJ->allProducts as $product){ 

						if(in_array($product->number,$options['pdown'])){ ?>
							<li id="item_<?php echo $product->number;?>"><?php echo $product->name;?></li>	
							
					<?php  }
					}
				}
				?>
				</ul>
				</div>
				<div class="multiselect">
					<div class="selectBox" onclick="showCheckboxesPDOWN()">
					  <select>
						<option>Select Product</option>
					  </select>
					  <div class="overSelect"></div>
					</div>
					<div class="checkboxes" id="checkboxesPDOWN">
						<?php foreach($EJ->allProducts as $product){ 
							$checked="";
							if(count($options['pdown'])){
								if(in_array($product->number,$options['pdown'])){
								$checked='checked';
								}
							}
						
						?>
						
					  <label for="pdown_item_<?php echo $product->number; ?>">
						<input onclick="checkboxChange(this,'pdownlist')" <?php echo $checked;?> name="<?php echo $this->plugin_name; ?>[pdown][]" value="<?php echo $product->number; ?>" type="checkbox" id="pdown_item_<?php echo $product->number; ?>" /><?php echo $product->name; ?></label>
						<?php } ?>
						
					</div>
				</div>
				</fieldset>
			</td>
		   <td>
				<fieldset>
					<legend><h3>Hidden Products</h3></legend>
				<div class="list_container">
				<ul id="phidlist">
				<?php 
				if(count($options['phid'])){
					foreach($EJ->allProducts as $product){ 

						if(in_array($product->number,$options['phid'])){ ?>
							<li id="item_<?php echo $product->number;?>"><?php echo $product->name;?></li>	
							
					<?php  }
					}
				}
				?>
				</ul>
				</div>	
				<div class="multiselect">
					<div class="selectBox" onclick="showCheckboxesPHID()">
					  <select>
						<option>Select Product</option>
					  </select>
					  <div class="overSelect"></div>
					</div>
					<div class="checkboxes" id="checkboxesPHID">
						<?php foreach($EJ->allProducts as $product){ 
							$checked="";
							if(count($options['phid'])){
								if(in_array($product->number,$options['phid'])){
								$checked='checked';
								}
							}
						?>
						
					  <label for="phid_item_<?php echo $product->number; ?>">
						<input onclick="checkboxChange(this,'phidlist')"  <?php echo $checked;?>  name="<?php echo $this->plugin_name; ?>[phid][]" value="<?php echo $product->number; ?>" type="checkbox" id="phid_item_<?php echo $product->number; ?>" /><?php echo $product->name; ?></label>
						<?php } ?>
						
					</div>
				</div>
				</fieldset>
			</td>
		   </tr>
		 
		 </table>
		 
		 
		 
		 
		 
		 <?php }?>

        
		
    </form>

</div>

