<?php
namespace EjunkieWPPlugin;
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @link              https://www.e-junkie.com/wordpress-plugins/
 * @since             1.0.0
 * @package           E_Junkie
 *
 * @wordpress-plugin
 * Plugin Name:       Sell Digital Downloads
 * Plugin URI:        https://www.e-junkie.com/wordpress-plugins/
 * Description:       E-junkie WordPress plugin to generate Shop or Individual Product pages. This can be used to create a complete shop to sell downloads and tangible goods using E-junkie API automatically.
 * Version:           1.2.0
 * Author:            E-Junkie
 * Author URI:        https://www.e-junkie.com/
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       e-junkie
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

error_reporting(E_ERROR | E_PARSE);
ini_set('display_errors', 0);

/**
 * Currently plugin version.
 */
define( 'PLUGIN_NAME_VERSION', '1.0.0' );

/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-e-junkie-activator.php
 */
function activate_e_junkie() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-e-junkie-activator.php';
	E_Junkie_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-e-junkie-deactivator.php
 */
function deactivate_e_junkie() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-e-junkie-deactivator.php';
	E_Junkie_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_e_junkie' );
register_deactivation_hook( __FILE__, 'deactivate_e_junkie' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-e-junkie.php';

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function run_e_junkie() {

	$plugin = new E_Junkie();
	$plugin->run();

}
run_e_junkie();
