<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
$options = get_option('e-junkie');
$Page = new stdClass();
$Client = new stdClass();

//get variables from WP db
$Client->client_id = $options['client-id'];
//no of related products to show
$Page->EJ->maxRelated = 5;
$Page->selectedCategory = null;
$Page->location=new stdClass();
$Page->selectedCategoryLevel = null;
$Page->theme="default";
$Page->EJ->maxRelated = isset($options['related'])?$options['related']:5;
$Page->EJ->pref->hide_out_of_stock = (isset($options['related']) && $options['related']=='yes')? true:false;
$Page->EJ->pref->hidden  = (isset($options['phid']) && count($options['phid']))?$options['phid']:null;
$Page->EJ->pref->pinned_down  =(isset($options['pdown']) && count($options['pdown']))?$options['pdown']:null;
$Page->EJ->pref->pinned  = (isset($options['pup']) && count($options['pup']))?$options['pup']:null;
$Page->pageNo = 1;
$tag = null;
$item = null;
$router=array();

//$current_url=$_SERVER['REQUEST_SCHEME']."://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
$current_url=(isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' ? 'https' : 'http')."://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
$URI_PARTS=explode("/",trim(str_replace(site_url(),"",$current_url),"/"));

if ( isset($URI_PARTS[0]) && !empty($URI_PARTS[0]) && $URI_PARTS[0]==$options['shop'])
	$router['name']='shop';

$router['params']['page'] = null;

if ( isset($URI_PARTS[1]) && !empty($URI_PARTS[1])){
	$router['name']='shop';
	if ( is_numeric($URI_PARTS[1]) && !empty($URI_PARTS[1]) ){
                $router['params']['page']=intval($URI_PARTS[1]);
        }
}

if ( isset($URI_PARTS[1]) && !empty($URI_PARTS[1]) && $URI_PARTS[1]=='tags'){
	$router['name']='tags';
	$router['params']['tag']="";
	if ( isset($URI_PARTS[2]) && !empty($URI_PARTS[2])){
		$router['params']['tag']=$URI_PARTS[2];
	}
	if ( !empty($URI_PARTS[3]) && is_numeric($URI_PARTS[3]) ){
    		$router['params']['page']=intval($URI_PARTS[3]);
    	}
}
if ( isset($URI_PARTS[1]) && !empty($URI_PARTS[1]) && $URI_PARTS[1]=='product')
{
	$router['name']='product';
	$router['params']['item']="";
		if ( isset($URI_PARTS[2]) && !empty($URI_PARTS[2])){
			$router['params']['item']=$URI_PARTS[2];
		}
}
//if tag/category page is called, set tag as in the request
if($router['name'] == 'tags'){
	$tag = $router['params']['tag'];
	$Page->selectedCategory = $tag; 
}

//if prodct page is called, set item as in the request
if($router['name'] == 'product') 
	$item = $router['params']['item'];

$Page->selectedCategory = urldecode($Page->selectedCategory);

//set page url as the user decided, such as shop/store/products

$Page->url = site_url()."/".$options['shop'];

$apikey=$options['client-api-key'];

if($router['params']['page'] == null)
	$Page->pageNo = 1;
else
	$Page->pageNo = intval($router['params']['page']);

//setting variables as per EJParser
$Page->EJ->clientId = $Client->client_id;
$Page->EJ->selectedCategory = $tag;
$Page->EJ->selectedProduct = $item;
$Page->EJ->apiKey = $apikey;
//$EJ = new EJParser($Client->client_id, $tag, $item, $Page->url, $category, null, $Page, $pageNo,$apikey,$options);
$EJ = new EjunkieWPPlugin\EJParser($Page->EJ->clientId, $Page->EJ->selectedCategory, $Page->EJ->selectedProduct, $Page, $Page->EJ->apiKey);
if($EJ->client == null || $EJ->totalCount == 0){
	//not a valid request as the Client / no products found
}

//override client details with data from wp
$clientInfo=new stdClass();
$clientInfo->client_id=$EJ->clientId;
$clientInfo->shop_name=$options['shop_name'];
$custom_logo_id = get_theme_mod( 'custom_logo' );
$logo=wp_get_attachment_image_src( $custom_logo_id);
$clientInfo->logo=$logo[0];
$EJ->client = $clientInfo;
$EJT = new EjunkieWPPlugin\EJTemplate($Page, null, $EJ);
if($router['name'] == 'shop'){
	//shop page called
	$EJ->getProducts();
}
else if($router['name'] == 'tags'){
	//tags page called
	$EJ->getTagProducts();
}
else if($router['name'] == 'product'){
	//product page called
	$EJ->getProduct();
}
add_action( 'wp_head', array($EJT,'change_meta'),2);
add_filter( 'pre_get_document_title', array($EJT,'change_title'),15);
if(count($EJ->products) == 0){
		status_header(404);
		include(get_404_template());
}
else{
	status_header(200);
	get_header(); 
	$EJT->generateShop();
	get_footer();
}

